Attribute VB_Name = "modPDFDllInterface"
Option Explicit
' these are the PDF funcitons. C++ changes the name of DLL modules.
' Change the patch of the dll as needed.

Public Declare Function pdfTrigger Lib "SII_PDF.DLL" Alias "_Trigger@4" (ByVal sKey As String) As Long

Public Declare Function pdfUnlockDLL Lib "SII_PDF.DLL" Alias "_UnlockDLL@4" (ByVal lKey As Long) As Long

Public Declare Function pdfOpenPDF Lib "SII_PDF.DLL" Alias "_OpenPDF@20" (ByVal sFileName As String, _
          ByVal bIgnoreProtect As Boolean, _
          ByVal sUserPassword As String, _
          ByVal sOwnerPassword As String, _
          ByRef lHandle As Long) As Long

Public Declare Function pdfClosePDF Lib "SII_PDF.DLL" Alias "_ClosePDF@4" (ByRef lHandle As Long) As Long

Public Declare Function pdfGetNumPages Lib "SII_PDF.DLL" Alias "_GetNumPages@4" (ByRef lHandle As Long) As Long

Public Declare Function pdfConvertPDFToTextFile Lib "SII_PDF.DLL" Alias "_ConvertPDFToTextFile@16" ( _
        ByVal lFirstPage As Long, _
        ByVal lLastPage As Long, _
        ByRef lPDFHandle As Long, _
        ByVal sOutputFile As String) As Long

Public Declare Function pdfConvertPDFToHTMLFile Lib "SII_PDF.DLL" Alias "_ConvertPDFToHTMLFile@16" ( _
        ByVal lFirstPage As Long, _
        ByVal lLastPage As Long, _
        ByRef lPDFHandle As Long, _
        ByVal sOutputFile As String) As Long

Public Declare Function pdfConvertPDFToText Lib "SII_PDF.DLL" Alias "_ConvertPDFToText@20" ( _
        ByVal lFirstPage As Long, _
        ByVal lLastPage As Long, _
        ByRef lPDFHandle As Long, _
        ByVal sBuffer As String, _
        ByVal lSize As Long) As Long

Public Declare Function pdfConvertPDFToHTML Lib "SII_PDF.DLL" Alias "_ConvertPDFToHTML@20" ( _
        ByVal lFirstPage As Long, _
        ByVal lLastPage As Long, _
        ByRef lPDFHandle As Long, _
        ByVal sBuffer As String, _
        ByVal lSize As Long) As Long

Public Declare Function pdfGetErrQuiet Lib "SII_PDF.DLL" Alias "_GetErrQuiet@0" () As Long
Public Declare Function pdfSetErrQuiet Lib "SII_PDF.DLL" Alias "_SetErrQuiet@4" (ByVal bErrQuietA As Boolean) ' Logging in File

Public Declare Function pdfGetTextEncoding Lib "SII_PDF.DLL" Alias "_GetTextEncoding@8" ( _
        ByRef sBuffer As String, _
        ByVal lSize As Long) As Long
        
' Text Settings ------------------------------------------------------------------------------------------------------Start
Public Declare Function pdfGetblkOverlapSlack Lib "SII_PDF.DLL" Alias "_GetblkOverlapSlack@0" () As Double
Public Declare Sub pdfSetblkOverlapSlack Lib "SII_PDF.DLL" Alias "_SetblkOverlapSlack@8" (ByVal dOverlap As Double)
Public Declare Function pdfGetflowMaxDeltaY Lib "SII_PDF.DLL" Alias "_GetflowMaxDeltaY@0" () As Double
Public Declare Sub pdfSetflowMaxDeltaY Lib "SII_PDF.DLL" Alias "_SetflowMaxDeltaY@8" (ByVal dMaxVert As Double)
Public Declare Function pdfGetblkMaxFontSizeRatio Lib "SII_PDF.DLL" Alias "_GetblkMaxFontSizeRatio@0" () As Double
Public Declare Sub pdfSetblkMaxFontSizeRatio Lib "SII_PDF.DLL" Alias "_SetblkMaxFontSizeRatio@8" (ByVal dMaxSize As Double)
Public Declare Function pdfGetblkMaxSpacing Lib "SII_PDF.DLL" Alias "_GetblkMaxSpacing@0" () As Double
Public Declare Sub pdfSetblkMaxSpacing Lib "SII_PDF.DLL" Alias "_SetblkMaxSpacing@8" (ByVal dMaxSpace As Double)
Public Declare Function pdfGetlineMaxSubscriptDeltaX Lib "SII_PDF.DLL" Alias "_GetlineMaxSubscriptDeltaX@0" () As Double
Public Declare Sub pdfSetlineMaxSubscriptDeltaX Lib "SII_PDF.DLL" Alias "_SetlineMaxSubscriptDeltaX@8" (ByVal dMaxSub As Double)
Public Declare Function pdfGetlineMaxSuperscriptDeltaX Lib "SII_PDF.DLL" Alias "_GetlineMaxSuperscriptDeltaX@0" () As Double
Public Declare Sub pdfSetlineMaxSuperscriptDeltaX Lib "SII_PDF.DLL" Alias "_SetlineMaxSuperscriptDeltaX@8" (ByVal dMaxSuper As Double)
Public Declare Function pdfGetlineMinSuperscriptFontSizeRatio Lib "SII_PDF.DLL" Alias "_GetlineMinSuperscriptFontSizeRatio@0" () As Double
Public Declare Sub pdfSetlineMinSuperscriptFontSizeRatio Lib "SII_PDF.DLL" Alias "_SetlineMinSuperscriptFontSizeRatio@8" (ByVal dSize As Double)
Public Declare Function pdfGetlineMaxSuperscriptFontSizeRatio Lib "SII_PDF.DLL" Alias "_GetlineMaxSuperscriptFontSizeRatio@0" () As Double
Public Declare Sub pdfSetlineMaxSuperscriptFontSizeRatio Lib "SII_PDF.DLL" Alias "_SetlineMaxSuperscriptFontSizeRatio@8" (ByVal dSize As Double)
Public Declare Function pdfGetlineMinSubscriptFontSizeRatio Lib "SII_PDF.DLL" Alias "_GetlineMinSubscriptFontSizeRatio@0" () As Double
Public Declare Sub pdfSetlineMinSubscriptFontSizeRatio Lib "SII_PDF.DLL" Alias "_SetlineMinSubscriptFontSizeRatio@8" (ByVal dSize As Double)
Public Declare Function pdfGetlineMaxSubscriptFontSizeRatio Lib "SII_PDF.DLL" Alias "_GetlineMaxSubscriptFontSizeRatio@0" () As Double
Public Declare Sub pdfSetlineMaxSubscriptFontSizeRatio Lib "SII_PDF.DLL" Alias "_SetlineMaxSubscriptFontSizeRatio@8" (ByVal dSize As Double)
Public Declare Function pdfGetlineMinSubscriptOverlap Lib "SII_PDF.DLL" Alias "_GetlineMinSubscriptOverlap@0" () As Double
Public Declare Sub pdfSetlineMinSubscriptOverlap Lib "SII_PDF.DLL" Alias "_SetlineMinSubscriptOverlap@8" (ByVal dMinSub As Double)
Public Declare Function pdfGetlineMinSuperscriptOverlap Lib "SII_PDF.DLL" Alias "_GetlineMinSuperscriptOverlap@0" () As Double
Public Declare Sub pdfSetlineMinSuperscriptOverlap Lib "SII_PDF.DLL" Alias "_SetlineMinSuperscriptOverlap@8" (ByVal dMinSuper As Double)
Public Declare Function pdfGetlineMinDeltaX Lib "SII_PDF.DLL" Alias "_GetlineMinDeltaX@0" () As Double
Public Declare Sub pdfSetlineMinDeltaX Lib "SII_PDF.DLL" Alias "_SetlineMinDeltaX@8" (ByVal dDeltaX As Double)
Public Declare Function pdfGetlineOverlapSlack Lib "SII_PDF.DLL" Alias "_GetlineOverlapSlack@0" () As Double
Public Declare Sub pdfSetlineOverlapSlack Lib "SII_PDF.DLL" Alias "_SetlineOverlapSlack@8" (ByVal dOverlap As Double)
Public Declare Function pdfGetlineMaxBaselineDelta Lib "SII_PDF.DLL" Alias "_GetlineMaxBaselineDelta@0" () As Double
Public Declare Sub pdfSetlineMaxBaselineDelta Lib "SII_PDF.DLL" Alias "_SetlineMaxBaselineDelta@8" (ByVal dMaxBase As Double)
Public Declare Function pdfGetlineMaxFontSizeRatio Lib "SII_PDF.DLL" Alias "_GetlineMaxFontSizeRatio@0" () As Double
Public Declare Sub pdfSetlineMaxFontSizeRatio Lib "SII_PDF.DLL" Alias "_SetlineMaxFontSizeRatio@8" (ByVal dMaxSize As Double)
Public Declare Function pdfGetdupMaxDeltaX Lib "SII_PDF.DLL" Alias "_GetdupMaxDeltaX@0" () As Double
Public Declare Sub pdfSetdupMaxDeltaX Lib "SII_PDF.DLL" Alias "_SetdupMaxDeltaX@8" (ByVal dDeltaX As Double)
Public Declare Function pdfGetdupMaxDeltaY Lib "SII_PDF.DLL" Alias "_GetdupMaxDeltaY@0" () As Double
Public Declare Sub pdfSetdupMaxDeltaY Lib "SII_PDF.DLL" Alias "_SetdupMaxDeltaY@8" (ByVal dDeltaY As Double)
Public Declare Function pdfGetwordDefMinSpaceWidth Lib "SII_PDF.DLL" Alias "_GetwordDefMinSpaceWidth@0" () As Double
Public Declare Sub pdfSetwordDefMinSpaceWidth Lib "SII_PDF.DLL" Alias "_SetwordDefMinSpaceWidth@8" (ByVal dWidth As Double)
Public Declare Function pdfGetwordDefMaxSpaceWidth Lib "SII_PDF.DLL" Alias "_GetwordDefMaxSpaceWidth@0" () As Double
Public Declare Sub pdfSetwordDefMaxSpaceWidth Lib "SII_PDF.DLL" Alias "_SetwordDefMaxSpaceWidth@8" (ByVal dWidth As Double)
Public Declare Function pdfGetwordMaxSpaceWidth Lib "SII_PDF.DLL" Alias "_GetwordMaxSpaceWidth@0" () As Double
Public Declare Sub pdfSetwordMaxSpaceWidth Lib "SII_PDF.DLL" Alias "_SetwordMaxSpaceWidth@8" (ByVal dWidth As Double)
Public Declare Function pdfGetwordMinSpaceWidth Lib "SII_PDF.DLL" Alias "_GetwordMinSpaceWidth@0" () As Double
Public Declare Sub pdfSetwordMinSpaceWidth Lib "SII_PDF.DLL" Alias "_SetwordMinSpaceWidth@8" (ByVal dWidth As Double)
' Text Settings ------------------------------------------------------------------------------------------------------End

' Undocumented items!!!!! ITEMS TO BE ADDED ONCE DOCUMENTED ---------------------------------------------------------START
Public Declare Sub pdfSetTextEncoding Lib "SII_PDF.DLL" Alias "_SetTextEncoding@4" (ByVal sEncodingName As String)
Public Declare Sub pdfSetblkMaxSortSpacing Lib "SII_PDF.DLL" Alias "_SetblkMaxSortSpacing@8" (ByVal dMaxSpace As Double)
Public Declare Function pdfGetblkMaxSortSpacing Lib "SII_PDF.DLL" Alias "_GetblkMaxSortSpacing@0" () As Double
' Undocumented items!!!!! ITEMS TO BE ADDED ONCE DOCUMENTED ---------------------------------------------------------End


'''''''''''''''''''''''''''''''''''''''''' DLL directly
''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''
' ConvertPDFToFile()
' -1 = "PDFCX: Unable to open necessary SII DLL"
' -2 = "PDFCX: File is invalid or could not open" + vbLf + "  " + msInputFile
' -5 = "PDFCX: Couldn't read the page catalog"
' -6 =  "PDFCX: PDF File is damaged"
' -7 =  "PDFCX: file is encrypted and password was incorrect or not supplied"
' -8 =  "PDFCX: User does not have permission to read"
' -9 =  "PDFCX: Invalid last page range specified"
' -10 = "PDFCX: Shareware expired"
' -11 = "PDFCX: Conversion failed"
Public Function ConvertPDFToFile(sInputFile As String, _
                            sOutputFile As String, _
                            bIgnoreProtect As Boolean, _
                            sPasswordUser As String, _
                            sPasswordOwner As String, _
                            lFirstPage As Long, _
                            lLastPage As Long, _
                            lTargetFileType As Long, _
                            sErr As String) As Long
  Dim PDF As Long, lResult As Long
  Dim lPages As Long

' ORDER IS CRITICAL A1
  If (bIgnoreProtect = True) Then
    lResult = pdfOpenPDF(sInputFile, 1, sPasswordUser, sPasswordOwner, PDF)
  Else
    lResult = pdfOpenPDF(sInputFile, 0, sPasswordUser, sPasswordOwner, PDF)
  End If
  
' ORDER IS CRITICAL A2 (Uncomment items below ONLY as needed)
'  Call pdfSetlineMaxSuperscriptDeltaX(md_tsLineMaxSubscriptDeltaX)
'  Call pdfSetlineMaxSuperscriptDeltaX(md_tsLineMaxSuperscriptDeltaX)
'  Call pdfSetblkMaxSpacing(md_tsBlockMaxSpacing)
'  Call pdfSetflowMaxDeltaY(md_tsFlowMaxDeltaY)
'  Call pdfSetblkOverlapSlack(md_tsBlockkOverlapSlack)
'  Call pdfSetblkMaxFontSizeRatio(md_tsBlockMaxFontSizeRatio)
'  Call pdfSetlineMaxSubscriptFontSizeRatio(md_tsLineMaxSubscriptFontSizeRatio)
'  Call pdfSetlineMinSubscriptFontSizeRatio(md_tsLineMinSubscriptFontSizeRatio)
'  Call pdfSetlineMaxSuperscriptFontSizeRatio(md_tsLineMaxSuperscriptFontSizeRatio)
'  Call pdfSetlineMinSuperscriptFontSizeRatio(md_tsLineMinSuperscriptFontSizeRatio)
'  Call pdfSetlineMinSuperscriptOverlap(md_tsLineMinSuperscriptOverlap)
'  Call pdfSetlineMinSubscriptOverlap(md_tsLineMinSubscriptOverlap)
'  Call pdfSetlineMinDeltaX(md_tsLineMinDeltaX)
'  Call pdfSetlineMaxFontSizeRatio(md_tsLineMaxFontSizeRatio)
'  Call pdfSetlineMaxBaselineDelta(md_tsLineMaxBaselineDelta)
'  Call pdfSetlineOverlapSlack(md_tsLineOverlapSlack)
'  Call pdfSetdupMaxDeltaY(md_tsSetDupMaxDeltaY)
Call pdfSetdupMaxDeltaX(0)
'  Call pdfSetwordDefMaxSpaceWidth(md_tsWordDefMaxSpaceWidth)
'  Call pdfSetwordDefMinSpaceWidth(md_tsWordDefMinSpaceWidth)
'  Call pdfSetwordMaxSpaceWidth(md_tsWordMaxSpaceWidth)
'  Call pdfSetwordMinSpaceWidth(md_tsWordMinSpaceWidth)
  
  If (lResult <> 0) Then
    Select Case lResult
      Case 1
        ConvertPDFToFile = -2
        sErr = "PDFCX\OpenPDF: File is invalid or could not open" + vbLf + "  " + sInputFile
      Case 2
        ConvertPDFToFile = -5
        sErr = "PDFCX\OpenPDF: Couldn't read the page catalog"
      Case 3
        ConvertPDFToFile = -6
        sErr = "PDFCX\OpenPDF: PDF File is damaged"
      Case 4
        ConvertPDFToFile = -7
        sErr = "PDFCX\OpenPDF: File is encrypted and password was incorrect or not supplied"
      Case 5
        ConvertPDFToFile = -8
        sErr = "PDFCX\OpenPDF: User does not have permission to read"
      Case 6
        sErr = "PDFCX\OpenPDF: Component not unlocked"
        ConvertPDFToFile = -10
    End Select
    pdfClosePDF (PDF)
    Exit Function
  End If
  
  lPages = pdfGetNumPages(PDF)
  If (lLastPage > lPages Or lFirstPage < 0) Then
      ConvertPDFToFile = -9
      sErr = "PDFCX: Invalid arguments"
      pdfClosePDF (PDF)
      Exit Function
  End If
  
  Select Case lTargetFileType
    Case 1 ' TEXT
      lResult = pdfConvertPDFToTextFile(lFirstPage, lLastPage, PDF, sOutputFile)
    Case 2 ' HTML
      lResult = pdfConvertPDFToHTMLFile(lFirstPage, lLastPage, PDF, sOutputFile)
  End Select
  
  If (lResult = 0) Then ' !!!!!!!!! Will change
    ConvertPDFToFile = -11
    sErr = "PDFCX: Failed to convert"
  Else
    ConvertPDFToFile = 0
  End If
  
  pdfClosePDF (PDF)
End Function

